#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w

eval 'exec /tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w -S $0 ${1+"$@"}'
    if 0; # not running under some shell
#
# Quarantined Attachment Release Request for PureMessage
# Copyright (C) 2004 Sophos Plc.
#
# This script is the first of a 2-stage release request.  This stage
# simply adds the request ot a journal, and the second stage does the
# bulk of the work.

use strict;
use PureMessage::MIME::Parser;
use PureMessage::Logger;
use PureMessage::Policy::RemoteScan::Config qw(%config);
use ActiveState::JournalDir;

# Find the queue id.
my $queue_id = '';
my $sender;
my $confidential = '';
my $logger = PureMessage::Logger->new(ident => 'release-request', 
                                  log_to => $config{profile}{common}{logfile});

my $mp = PureMessage::MIME::Parser->new;
$mp->decode_te(1);
$mp->handler(part_start => sub {
    my ($p, $hdrs, $ct, $ct_param, $te) = @_;
    if (!$queue_id and $hdrs =~ /^To:.*\+([^@%"]+)"?[@%]/mi) {
        $queue_id = $1;
    }
    if (!$sender and $hdrs =~ /^From:\s*(.*)$/mi) {
        $sender = $1;
    }
    if (!$confidential and $hdrs =~ /^Subject:.*\[confidential\]/mi) {
        $confidential = 1;
    }
});
while (<>) {
    $mp->parse($_);
}
$mp->eof;
exit unless $queue_id;

my $log_entry = sprintf "Release request for%s message %s%s",
                        ($confidential ? " confidential" : ""),
                        $queue_id, 
                        ($sender ? " from '$sender'" : "");

$logger->log("INFO", $log_entry);


my $jd = ActiveState::JournalDir->new($config{profile}{common}{journal_directory});

my $journal_entry = $jd->create($queue_id);

$journal_entry = 
        "SENDER " . ($sender ? "$sender\n" : "\n") .
        "CONFIDENTIAL " . ($confidential ? "1\n" : "0\n") .
        "SEARCH_COUNT 0\n" .
        "RECIEVED_AT " . localtime() . 
        "\n\n";

$jd->update($queue_id, $journal_entry);


